#!/bin/bash
#
# Copyright (C) 2012 Intel Corporation.
# Copyright (C) 2012 Casey Schaufler <casey@schaufler-ca.com>
#
fetch=tail
#fetch=cat
expected=0
unexpected=0

if [ -f /sys/fs/smackfs/cipso2 ]
then
    CIPSO=/sys/fs/smackfs/cipso2
elif [ -f /smack/cipso2 ]
then
    CIPSO=/smack/cipso2
else
    echo "No cipso control file found"
    exit 1
fi

if [ -f /sys/fs/smackfs/load2 ]
then
    LOAD=/sys/fs/smackfs/load2
elif [ -f /smack/load2 ]
then
    LOAD=/smack/load2
else
    echo "No load control file found"
    exit 1
fi

sed -e 's/\([^ ]*\) .*/\1/' $CIPSO \
	| fgrep -v '*' \
	> /tmp/testallaccess.list

for i in `$fetch /tmp/testallaccess.list` '*'
do
    for j in `$fetch /tmp/testallaccess.list` '*'
    do
        invalid=0
        success=0
        failure=0
        for k in r rw rwx rwxa rwxat 'r.*x' 'r.*xa' 'r.*xat' 'r.*a' \
                 'r.*a.*t' 'r.*t' w wx wxa wxat 'wx.*t' 'w.*t' x xa \
                 xat 'x.*t' a at t
        do
            klean=`echo "$k" | sed -e 's/\.\*//g'`
            rule=`fgrep -m 1 "$i $j " $LOAD`
            greprc=$?
            testtext=`./testaccess access "$i" "$j" "$klean"`
            testrc=$?
            testtext2=`./testaccess access2 "$i" "$j" "$klean"`
            testrc2=$?

            if [ "$i" = "*" ] ; then
                rulemode="-"
		pf="SS"
            elif [ "$i" = "@" -o "$j" = "@" ] ; then
                rulemode="rwxat"
		pf="AT"
            elif [ "$j" = "*" ] ; then
                rulemode="rwxat"
		pf="SO"
            elif [ "$i" = "$j" ] ; then
                rulemode="rwxat"
		pf="EQ"
            elif [ $greprc = 0 ] ; then
                rulemode=`echo $rule | sed -e 's/.* //'`
		pf="RF"
            else
                rulemode="-"
		pf="NR"
            fi

            if [ "$j" = "_" ] ; then
                if [ "$klean" = "r" -o "$klean" = "x" -o \
                     "$klean" = "rx" -o "$klean" = "rt" -o \
                     "$klean" = "xt" -o "$klean" = "rxt" ] ; then
                    rulemode="$k"
                fi
            fi

            if [ "$i" = "^" ] ; then
                if [ "$klean" = "r" -o "$klean" = "x" -o \
                     "$klean" = "rx" -o "$klean" = "rt" -o \
                     "$klean" = "xt" -o "$klean" = "rxt" ] ; then
                    rulemode="$k"
                fi
            fi

            echo "$rulemode" | grep -q "$k"
            if [ "$?" = 0 ] ; then
                # expect success
                if [ $testrc2 = 0 ] ; then
                    if [ $testrc = 0 ] ; then
                        expected=`expr $expected + 1`
                        success=`expr $success + 1`
                    elif [ $testrc = 2 ] ; then
                        success=`expr $success + 1`
                        expected=`expr $expected + 1`
                        invalid=`expr $invalid + 1`
                    elif [ $testrc = 1 -a $testrc2 = 0 -a "$i" = "^" ] ; then
                        success=`expr $success + 1`
                        expected=`expr $expected + 1`
                    else
                        unexpected=`expr $unexpected + 1`
                        failure=`expr $failure + 1`
                        echo "$pf""$testrc""$testrc2" "$i" "$j" "$k" "$testtxt" "$testtxt2" "(""$expected"")"
                    fi
                fi
            else
                # expect failure
                if [ $testrc2 = 0 -o $testrc = 0 ] ; then
                    unexpected=`expr $unexpected + 1`
                    success=`expr $success + 1`
                    echo "$pf""$testrc""$testrc2" "$i" "$j" "$k" "$testtxt" "$testtxt2" "(""$expected"")"
                else
                    failure=`expr $failure + 1`
                    expected=`expr $expected + 1`
                fi
            fi
        done
        echo "$i" "$j" "(""$invalid""/""$failure""/""$success"")" \
             "(""$unexpected""/""$expected"")"
    done
done
echo "(""$unexpected""/""$expected"")"
